-- {{{ HEADER: File headers
module ToccLocalsDecl where

import AbsTocc

-- }}}

-- {{{ DATA: LocalValue/Indexing declaration

data LocalValue = ValueUnknown | ValueIterator | ValueKnownExpandTime | ValueInt Integer
                  deriving (Eq,Ord,Show)


data LocalIndex = IndexNone | IndexUnknown | IndexIterator | IndexInt Integer
                  deriving (Eq,Ord,Show)


-- }}}

-- {{{ DATA: Local/Locals declaration

data Local = Local  { locQualifier :: Qualifier_spec,
                      locType      :: Type_spec,
                      locArray     :: Array_spec,
                      locIndex     :: LocalIndex,
                      locName      :: String, 
                      locValue     :: LocalValue
                    } deriving (Eq,Ord,Show)
  
type Locals = [Local]


defLocal :: Local
defLocal = Local QualReadWrite TypeInt ArrayNone IndexNone "" ValueUnknown 


-- }}}

