module AbsTocc where

-- Haskell module generated by the BNF converter

newtype CapIdent = CapIdent String deriving (Eq,Ord,Show)
newtype LowerIdent = LowerIdent String deriving (Eq,Ord,Show)
newtype UpperIdent = UpperIdent String deriving (Eq,Ord,Show)
data Init_spec =
   InitExp Exp
 | InitNone
  deriving (Eq,Ord,Show)

data Decl_spec =
   Decl Qualifier_spec Type_spec Array_spec LowerIdent
  deriving (Eq,Ord,Show)

data Array_spec =
   ArraySized Exp
 | ArrayUnknown
 | ArrayNone
  deriving (Eq,Ord,Show)

data Variable_spec =
   Var Decl_spec Init_spec
  deriving (Eq,Ord,Show)

data Param_spec =
   Param Decl_spec
  deriving (Eq,Ord,Show)

data Qualifier_spec =
   QualConst
 | QualChannel
 | QualChannelIn
 | QualChannelOut
 | QualByVal
 | QualReadWrite
  deriving (Eq,Ord,Show)

data Type_spec =
   TypeString
 | TypeBool
 | TypeInt
 | TypeFloat
 | TypeCustom UpperIdent
  deriving (Eq,Ord,Show)

data Program_spec =
   Program [Global_spec]
  deriving (Eq,Ord,Show)

data Global_spec =
   GlobalProcess CapIdent [Param_spec] SingleStBlock_spec
 | GlobalTypedef UpperIdent Type_spec Array_spec
 | GlobalInclude String
 | GlobalSInclude String
  deriving (Eq,Ord,Show)

data Block_spec =
   Block [Variable_spec] [Proc_spec]
  deriving (Eq,Ord,Show)

data SingleStBlock_spec =
   SingleStBlock [Variable_spec] [Proc_spec]
  deriving (Eq,Ord,Show)

data Order_spec =
   OrderSeq
 | OrderPar
  deriving (Eq,Ord,Show)

data Proc_spec =
   ProcAlt Alt_spec
 | ProcAssign LowerIdent Assignment_op Exp
 | ProcAssignArr LowerIdent Exp Assignment_op Exp
 | ProcCall CapIdent [Arg_spec]
 | ProcComm Comm_spec
 | ProcDelay Exp
 | ProcElse SingleStBlock_spec
 | ProcElseIf Exp SingleStBlock_spec
 | ProcExp Exp
 | ProcFor Order_spec LowerIdent Exp Exp SingleStBlock_spec
 | ProcIf Exp SingleStBlock_spec
 | ProcOrder Order_spec Block_spec
 | ProcPrint [Exp]
 | ProcSkip
 | ProcStop
 | ProcTime Exp SingleStBlock_spec
 | ProcWhile Exp SingleStBlock_spec
  deriving (Eq,Ord,Show)

data Arg_spec =
   Arg Exp
  deriving (Eq,Ord,Show)

data Comm_spec =
   CommSend LowerIdent LowerIdent
 | CommRecv LowerIdent LowerIdent
  deriving (Eq,Ord,Show)

data Alt_spec =
   Alt [AltAlt_spec]
 | AltRepl LowerIdent Exp Exp [AltAlt_spec]
  deriving (Eq,Ord,Show)

data AltComm_spec =
   AltCommRecv LowerIdent LowerIdent
  deriving (Eq,Ord,Show)

data AltAlt_spec =
   AltAltNested Alt_spec
 | AltAltGuard Exp AltComm_spec SingleStBlock_spec
 | AltAltSkip Exp
 | AltAlt AltComm_spec SingleStBlock_spec
  deriving (Eq,Ord,Show)

data Assignment_op =
   Assign
 | AssignMul
 | AssignDiv
 | AssignMod
 | AssignAdd
 | AssignSub
 | AssignLeft
 | AssignRight
 | AssignAnd
 | AssignXor
 | AssignOr
  deriving (Eq,Ord,Show)

data ConstVal_spec =
   ConstInt Integer
 | ConstFloat Double
 | ConstString String
 | ConstTrue
 | ConstFalse
 | ConstChar Char
  deriving (Eq,Ord,Show)

data Exp =
   ExpLor Exp Exp
 | ExpLand Exp Exp
 | Expeq Exp Exp
 | Expneq Exp Exp
 | Explthen Exp Exp
 | Expgrthen Exp Exp
 | Exple Exp Exp
 | Expge Exp Exp
 | ExpBitor Exp Exp
 | ExpBitexor Exp Exp
 | ExpBitand Exp Exp
 | ExpLeft Exp Exp
 | ExpRight Exp Exp
 | ExpPlus Exp Exp
 | ExpMinus Exp Exp
 | ExpTimes Exp Exp
 | ExpDiv Exp Exp
 | ExpMod Exp Exp
 | ExpNegative Exp
 | ExpPositive Exp
 | ExpIndex LowerIdent Exp
 | ExpFunc LowerIdent [Exp]
 | ExpConst ConstVal_spec
 | ExpVar LowerIdent
  deriving (Eq,Ord,Show)

