-- This Happy file was machine-generated by the BNF converter
{
module ParTocc where
import AbsTocc
import LexTocc
import ErrM
}

%name pProgram_spec Program_spec

-- no lexer declaration
%monad { Err } { thenM } { returnM }
%tokentype { Token }

%token 
 '=' { PT _ (TS "=") }
 '[' { PT _ (TS "[") }
 ']' { PT _ (TS "]") }
 ';' { PT _ (TS ";") }
 ',' { PT _ (TS ",") }
 '(' { PT _ (TS "(") }
 ')' { PT _ (TS ")") }
 ':' { PT _ (TS ":") }
 '{' { PT _ (TS "{") }
 '}' { PT _ (TS "}") }
 '!' { PT _ (TS "!") }
 '?' { PT _ (TS "?") }
 '->' { PT _ (TS "->") }
 '*=' { PT _ (TS "*=") }
 '/=' { PT _ (TS "/=") }
 '%=' { PT _ (TS "%=") }
 '+=' { PT _ (TS "+=") }
 '-=' { PT _ (TS "-=") }
 '<<=' { PT _ (TS "<<=") }
 '>>=' { PT _ (TS ">>=") }
 '&=' { PT _ (TS "&=") }
 '^=' { PT _ (TS "^=") }
 '|=' { PT _ (TS "|=") }
 '||' { PT _ (TS "||") }
 '&&' { PT _ (TS "&&") }
 '==' { PT _ (TS "==") }
 '!=' { PT _ (TS "!=") }
 '<' { PT _ (TS "<") }
 '>' { PT _ (TS ">") }
 '<=' { PT _ (TS "<=") }
 '>=' { PT _ (TS ">=") }
 '|' { PT _ (TS "|") }
 '^' { PT _ (TS "^") }
 '&' { PT _ (TS "&") }
 '<<' { PT _ (TS "<<") }
 '>>' { PT _ (TS ">>") }
 '+' { PT _ (TS "+") }
 '-' { PT _ (TS "-") }
 '*' { PT _ (TS "*") }
 '/' { PT _ (TS "/") }
 '%' { PT _ (TS "%") }
 'ALT' { PT _ (TS "ALT") }
 'BOOL' { PT _ (TS "BOOL") }
 'CHAN' { PT _ (TS "CHAN") }
 'CINCLUDE' { PT _ (TS "CINCLUDE") }
 'CONST' { PT _ (TS "CONST") }
 'CSYSINCLUDE' { PT _ (TS "CSYSINCLUDE") }
 'DELAY' { PT _ (TS "DELAY") }
 'ELSE' { PT _ (TS "ELSE") }
 'FOR' { PT _ (TS "FOR") }
 'IF' { PT _ (TS "IF") }
 'IN' { PT _ (TS "IN") }
 'INT' { PT _ (TS "INT") }
 'OUT' { PT _ (TS "OUT") }
 'PAR' { PT _ (TS "PAR") }
 'PRINT' { PT _ (TS "PRINT") }
 'PROC' { PT _ (TS "PROC") }
 'REAL' { PT _ (TS "REAL") }
 'SEQ' { PT _ (TS "SEQ") }
 'SKIP' { PT _ (TS "SKIP") }
 'STOP' { PT _ (TS "STOP") }
 'STRING' { PT _ (TS "STRING") }
 'TIME' { PT _ (TS "TIME") }
 'TO' { PT _ (TS "TO") }
 'TYPE' { PT _ (TS "TYPE") }
 'VAL' { PT _ (TS "VAL") }
 'WHILE' { PT _ (TS "WHILE") }
 'false' { PT _ (TS "false") }
 'true' { PT _ (TS "true") }

L_quoted { PT _ (TL $$) }
L_integ  { PT _ (TI $$) }
L_doubl  { PT _ (TD $$) }
L_charac { PT _ (TC $$) }
L_CapIdent { PT _ (T_CapIdent $$) }
L_LowerIdent { PT _ (T_LowerIdent $$) }
L_UpperIdent { PT _ (T_UpperIdent $$) }
L_err    { _ }


%%

String  :: { String }  : L_quoted { $1 }
Integer :: { Integer } : L_integ  { (read $1) :: Integer }
Double  :: { Double }  : L_doubl  { (read $1) :: Double }
Char    :: { Char }    : L_charac { (read $1) :: Char }
CapIdent    :: { CapIdent} : L_CapIdent { CapIdent ($1)}
LowerIdent    :: { LowerIdent} : L_LowerIdent { LowerIdent ($1)}
UpperIdent    :: { UpperIdent} : L_UpperIdent { UpperIdent ($1)}

Init_spec :: { Init_spec }
Init_spec : '=' Exp1 { InitExp $2 } 
  | {- empty -} { InitNone }


Decl_spec :: { Decl_spec }
Decl_spec : Qualifier_spec Type_spec Array_spec LowerIdent { Decl $1 $2 $3 $4 } 


Array_spec :: { Array_spec }
Array_spec : '[' Exp1 ']' { ArraySized $2 } 
  | '[' ']' { ArrayUnknown }
  | {- empty -} { ArrayNone }


Variable_spec :: { Variable_spec }
Variable_spec : Decl_spec Init_spec { Var $1 $2 } 


ListVariable_spec :: { [Variable_spec] }
ListVariable_spec : {- empty -} { [] } 
  | ListVariable_spec Variable_spec ';' { flip (:) $1 $2 }


Param_spec :: { Param_spec }
Param_spec : Decl_spec { Param $1 } 


ListParam_spec :: { [Param_spec] }
ListParam_spec : {- empty -} { [] } 
  | Param_spec { (:[]) $1 }
  | Param_spec ',' ListParam_spec { (:) $1 $3 }


Qualifier_spec :: { Qualifier_spec }
Qualifier_spec : 'CONST' { QualConst } 
  | 'CHAN' { QualChannel }
  | 'IN' { QualChannelIn }
  | 'OUT' { QualChannelOut }
  | 'VAL' { QualByVal }
  | {- empty -} { QualReadWrite }


Type_spec :: { Type_spec }
Type_spec : 'STRING' { TypeString } 
  | 'BOOL' { TypeBool }
  | 'INT' { TypeInt }
  | 'REAL' { TypeFloat }
  | UpperIdent { TypeCustom $1 }


Program_spec :: { Program_spec }
Program_spec : ListGlobal_spec { Program $1 } 


Global_spec :: { Global_spec }
Global_spec : 'PROC' CapIdent '(' ListParam_spec ')' ':' SingleStBlock_spec { GlobalProcess $2 $4 $7 } 
  | 'TYPE' UpperIdent '=' Type_spec Array_spec { GlobalTypedef $2 $4 $5 }
  | 'CINCLUDE' String { GlobalInclude $2 }
  | 'CSYSINCLUDE' String { GlobalSInclude $2 }


ListGlobal_spec :: { [Global_spec] }
ListGlobal_spec : {- empty -} { [] } 
  | Global_spec { (:[]) $1 }
  | Global_spec ';' ListGlobal_spec { (:) $1 $3 }


Block_spec :: { Block_spec }
Block_spec : '{' ListVariable_spec ListProc_spec '}' { Block (reverse $2) $3 } 


SingleStBlock_spec :: { SingleStBlock_spec }
SingleStBlock_spec : '{' ListVariable_spec ListProc_spec '}' { SingleStBlock (reverse $2) $3 } 


Order_spec :: { Order_spec }
Order_spec : 'SEQ' { OrderSeq } 
  | 'PAR' { OrderPar }


Proc_spec :: { Proc_spec }
Proc_spec : Alt_spec { ProcAlt $1 } 
  | LowerIdent Assignment_op Exp1 { ProcAssign $1 $2 $3 }
  | LowerIdent '[' Exp1 ']' Assignment_op Exp1 { ProcAssignArr $1 $3 $5 $6 }
  | CapIdent '(' ListArg_spec ')' { ProcCall $1 $3 }
  | Comm_spec { ProcComm $1 }
  | 'DELAY' Exp1 { ProcDelay $2 }
  | 'ELSE' ':' SingleStBlock_spec { ProcElse $3 }
  | 'ELSE' 'IF' Exp1 ':' SingleStBlock_spec { ProcElseIf $3 $5 }
  | Exp1 { ProcExp $1 }
  | Order_spec 'FOR' LowerIdent '=' Exp1 'TO' Exp1 ':' SingleStBlock_spec { ProcFor $1 $3 $5 $7 $9 }
  | 'IF' Exp1 ':' SingleStBlock_spec { ProcIf $2 $4 }
  | Order_spec ':' Block_spec { ProcOrder $1 $3 }
  | 'PRINT' ListExp1 { ProcPrint $2 }
  | 'SKIP' { ProcSkip }
  | 'STOP' { ProcStop }
  | 'TIME' Exp1 ':' SingleStBlock_spec { ProcTime $2 $4 }
  | 'WHILE' Exp1 ':' SingleStBlock_spec { ProcWhile $2 $4 }


ListProc_spec :: { [Proc_spec] }
ListProc_spec : Proc_spec { (:[]) $1 } 
  | Proc_spec ';' ListProc_spec { (:) $1 $3 }


Arg_spec :: { Arg_spec }
Arg_spec : Exp1 { Arg $1 } 


ListArg_spec :: { [Arg_spec] }
ListArg_spec : {- empty -} { [] } 
  | Arg_spec { (:[]) $1 }
  | Arg_spec ',' ListArg_spec { (:) $1 $3 }


Comm_spec :: { Comm_spec }
Comm_spec : LowerIdent '!' LowerIdent { CommSend $1 $3 } 
  | LowerIdent '?' LowerIdent { CommRecv $1 $3 }


Alt_spec :: { Alt_spec }
Alt_spec : 'ALT' ':' '{' ListAltAlt_spec '}' { Alt $4 } 
  | 'ALT' 'FOR' LowerIdent '=' Exp1 'TO' Exp1 ':' '{' ListAltAlt_spec '}' { AltRepl $3 $5 $7 $10 }


AltComm_spec :: { AltComm_spec }
AltComm_spec : LowerIdent '?' LowerIdent { AltCommRecv $1 $3 } 


AltAlt_spec :: { AltAlt_spec }
AltAlt_spec : Alt_spec { AltAltNested $1 } 
  | Exp1 '->' AltComm_spec ':' SingleStBlock_spec { AltAltGuard $1 $3 $5 }
  | Exp1 '->' 'SKIP' { AltAltSkip $1 }
  | AltComm_spec ':' SingleStBlock_spec { AltAlt $1 $3 }


ListAltAlt_spec :: { [AltAlt_spec] }
ListAltAlt_spec : AltAlt_spec { (:[]) $1 } 
  | AltAlt_spec ';' ListAltAlt_spec { (:) $1 $3 }


Assignment_op :: { Assignment_op }
Assignment_op : '=' { Assign } 
  | '*=' { AssignMul }
  | '/=' { AssignDiv }
  | '%=' { AssignMod }
  | '+=' { AssignAdd }
  | '-=' { AssignSub }
  | '<<=' { AssignLeft }
  | '>>=' { AssignRight }
  | '&=' { AssignAnd }
  | '^=' { AssignXor }
  | '|=' { AssignOr }


ConstVal_spec :: { ConstVal_spec }
ConstVal_spec : Integer { ConstInt $1 } 
  | Double { ConstFloat $1 }
  | String { ConstString $1 }
  | 'true' { ConstTrue }
  | 'false' { ConstFalse }
  | Char { ConstChar $1 }


Exp1 :: { Exp }
Exp1 : Exp1 '||' Exp2 { ExpLor $1 $3 } 
  | Exp2 { $1 }


Exp2 :: { Exp }
Exp2 : Exp2 '&&' Exp3 { ExpLand $1 $3 } 
  | Exp3 { $1 }


Exp3 :: { Exp }
Exp3 : Exp3 '==' Exp4 { Expeq $1 $3 } 
  | Exp3 '!=' Exp4 { Expneq $1 $3 }
  | Exp4 { $1 }


Exp4 :: { Exp }
Exp4 : Exp4 '<' Exp5 { Explthen $1 $3 } 
  | Exp4 '>' Exp5 { Expgrthen $1 $3 }
  | Exp4 '<=' Exp5 { Exple $1 $3 }
  | Exp4 '>=' Exp5 { Expge $1 $3 }
  | Exp5 { $1 }


Exp5 :: { Exp }
Exp5 : Exp5 '|' Exp6 { ExpBitor $1 $3 } 
  | Exp6 { $1 }


Exp6 :: { Exp }
Exp6 : Exp6 '^' Exp7 { ExpBitexor $1 $3 } 
  | Exp7 { $1 }


Exp7 :: { Exp }
Exp7 : Exp7 '&' Exp8 { ExpBitand $1 $3 } 
  | Exp8 { $1 }


Exp8 :: { Exp }
Exp8 : Exp8 '<<' Exp9 { ExpLeft $1 $3 } 
  | Exp8 '>>' Exp9 { ExpRight $1 $3 }
  | Exp9 { $1 }


Exp9 :: { Exp }
Exp9 : Exp9 '+' Exp10 { ExpPlus $1 $3 } 
  | Exp9 '-' Exp10 { ExpMinus $1 $3 }
  | Exp10 { $1 }


Exp10 :: { Exp }
Exp10 : Exp10 '*' Exp11 { ExpTimes $1 $3 } 
  | Exp10 '/' Exp11 { ExpDiv $1 $3 }
  | Exp10 '%' Exp11 { ExpMod $1 $3 }
  | Exp11 { $1 }


Exp11 :: { Exp }
Exp11 : '-' Exp11 { ExpNegative $2 } 
  | '+' Exp11 { ExpPositive $2 }
  | Exp12 { $1 }


Exp12 :: { Exp }
Exp12 : LowerIdent '[' Exp1 ']' { ExpIndex $1 $3 } 
  | LowerIdent '(' ListExp1 ')' { ExpFunc $1 $3 }
  | Exp13 { $1 }


Exp13 :: { Exp }
Exp13 : ConstVal_spec { ExpConst $1 } 
  | LowerIdent { ExpVar $1 }
  | '(' Exp ')' { $2 }


Exp :: { Exp }
Exp : Exp1 { $1 } 


ListExp1 :: { [Exp] }
ListExp1 : {- empty -} { [] } 
  | Exp1 { (:[]) $1 }
  | Exp1 ',' ListExp1 { (:) $1 $3 }



{

returnM :: a -> Err a
returnM = return

thenM :: Err a -> (a -> Err b) -> Err b
thenM = (>>=)

happyError :: [Token] -> Err a
happyError ts =
  Bad $ "syntax error at " ++ tokenPos ts ++ if null ts then [] else (" before " ++ unwords (map prToken (take 4 ts)))

myLexer = tokens
}

