module SkelTocc where

-- Haskell module generated by the BNF converter

import AbsTocc
import ErrM
type Result = Err String

failure :: Show a => a -> Result
failure x = Bad $ "Undefined case: " ++ show x

transCapIdent :: CapIdent -> Result
transCapIdent x = case x of
  CapIdent str  -> failure x


transLowerIdent :: LowerIdent -> Result
transLowerIdent x = case x of
  LowerIdent str  -> failure x


transUpperIdent :: UpperIdent -> Result
transUpperIdent x = case x of
  UpperIdent str  -> failure x


transInit_spec :: Init_spec -> Result
transInit_spec x = case x of
  InitExp exp  -> failure x
  InitNone  -> failure x


transDecl_spec :: Decl_spec -> Result
transDecl_spec x = case x of
  Decl qualifier_spec type_spec array_spec lowerident  -> failure x


transArray_spec :: Array_spec -> Result
transArray_spec x = case x of
  ArraySized exp  -> failure x
  ArrayUnknown  -> failure x
  ArrayNone  -> failure x


transVariable_spec :: Variable_spec -> Result
transVariable_spec x = case x of
  Var decl_spec init_spec  -> failure x


transParam_spec :: Param_spec -> Result
transParam_spec x = case x of
  Param decl_spec  -> failure x


transQualifier_spec :: Qualifier_spec -> Result
transQualifier_spec x = case x of
  QualConst  -> failure x
  QualChannel  -> failure x
  QualChannelIn  -> failure x
  QualChannelOut  -> failure x
  QualByVal  -> failure x
  QualReadWrite  -> failure x


transType_spec :: Type_spec -> Result
transType_spec x = case x of
  TypeString  -> failure x
  TypeBool  -> failure x
  TypeInt  -> failure x
  TypeFloat  -> failure x
  TypeCustom upperident  -> failure x


transProgram_spec :: Program_spec -> Result
transProgram_spec x = case x of
  Program global_specs  -> failure x


transGlobal_spec :: Global_spec -> Result
transGlobal_spec x = case x of
  GlobalProcess capident param_specs singlestblock_spec  -> failure x
  GlobalTypedef upperident type_spec array_spec  -> failure x
  GlobalInclude str  -> failure x
  GlobalSInclude str  -> failure x


transBlock_spec :: Block_spec -> Result
transBlock_spec x = case x of
  Block variable_specs proc_specs  -> failure x


transSingleStBlock_spec :: SingleStBlock_spec -> Result
transSingleStBlock_spec x = case x of
  SingleStBlock variable_specs proc_specs  -> failure x


transOrder_spec :: Order_spec -> Result
transOrder_spec x = case x of
  OrderSeq  -> failure x
  OrderPar  -> failure x


transProc_spec :: Proc_spec -> Result
transProc_spec x = case x of
  ProcAlt alt_spec  -> failure x
  ProcAssign lowerident assignment_op exp  -> failure x
  ProcAssignArr lowerident exp0 assignment_op exp  -> failure x
  ProcCall capident arg_specs  -> failure x
  ProcComm comm_spec  -> failure x
  ProcDelay exp  -> failure x
  ProcElse singlestblock_spec  -> failure x
  ProcElseIf exp singlestblock_spec  -> failure x
  ProcExp exp  -> failure x
  ProcFor order_spec lowerident exp0 exp singlestblock_spec  -> failure x
  ProcIf exp singlestblock_spec  -> failure x
  ProcOrder order_spec block_spec  -> failure x
  ProcPrint exps  -> failure x
  ProcSkip  -> failure x
  ProcStop  -> failure x
  ProcTime exp singlestblock_spec  -> failure x
  ProcWhile exp singlestblock_spec  -> failure x


transArg_spec :: Arg_spec -> Result
transArg_spec x = case x of
  Arg exp  -> failure x


transComm_spec :: Comm_spec -> Result
transComm_spec x = case x of
  CommSend lowerident0 lowerident  -> failure x
  CommRecv lowerident0 lowerident  -> failure x


transAlt_spec :: Alt_spec -> Result
transAlt_spec x = case x of
  Alt altalt_specs  -> failure x
  AltRepl lowerident exp0 exp altalt_specs  -> failure x


transAltComm_spec :: AltComm_spec -> Result
transAltComm_spec x = case x of
  AltCommRecv lowerident0 lowerident  -> failure x


transAltAlt_spec :: AltAlt_spec -> Result
transAltAlt_spec x = case x of
  AltAltNested alt_spec  -> failure x
  AltAltGuard exp altcomm_spec singlestblock_spec  -> failure x
  AltAltSkip exp  -> failure x
  AltAlt altcomm_spec singlestblock_spec  -> failure x


transAssignment_op :: Assignment_op -> Result
transAssignment_op x = case x of
  Assign  -> failure x
  AssignMul  -> failure x
  AssignDiv  -> failure x
  AssignMod  -> failure x
  AssignAdd  -> failure x
  AssignSub  -> failure x
  AssignLeft  -> failure x
  AssignRight  -> failure x
  AssignAnd  -> failure x
  AssignXor  -> failure x
  AssignOr  -> failure x


transConstVal_spec :: ConstVal_spec -> Result
transConstVal_spec x = case x of
  ConstInt n  -> failure x
  ConstFloat d  -> failure x
  ConstString str  -> failure x
  ConstTrue  -> failure x
  ConstFalse  -> failure x
  ConstChar c  -> failure x


transExp :: Exp -> Result
transExp x = case x of
  ExpLor exp0 exp  -> failure x
  ExpLand exp0 exp  -> failure x
  Expeq exp0 exp  -> failure x
  Expneq exp0 exp  -> failure x
  Explthen exp0 exp  -> failure x
  Expgrthen exp0 exp  -> failure x
  Exple exp0 exp  -> failure x
  Expge exp0 exp  -> failure x
  ExpBitor exp0 exp  -> failure x
  ExpBitexor exp0 exp  -> failure x
  ExpBitand exp0 exp  -> failure x
  ExpLeft exp0 exp  -> failure x
  ExpRight exp0 exp  -> failure x
  ExpPlus exp0 exp  -> failure x
  ExpMinus exp0 exp  -> failure x
  ExpTimes exp0 exp  -> failure x
  ExpDiv exp0 exp  -> failure x
  ExpMod exp0 exp  -> failure x
  ExpNegative exp  -> failure x
  ExpPositive exp  -> failure x
  ExpIndex lowerident exp  -> failure x
  ExpFunc lowerident exps  -> failure x
  ExpConst constval_spec  -> failure x
  ExpVar lowerident  -> failure x



