#ifndef __INCLUDE_CODEPROC_HPP__
#define __INCLUDE_CODEPROC_HPP__

#include "Proc.hpp"
#include "lib.hpp"

#include <string>

class CodeProc : public Proc {
	int execStart;
	public:
		CodeProc(Proc* pop) :
			Proc(pop), execStart(0) {}

		int getExecStart() {
			return execStart;
		}

		void setExecStart(int t) {
			execStart = t;
		}

		virtual void run() {
			assert(!"Compiler error: CodeProc with abstract run().");
		}

		virtual int getExecTime() const {
			assert(!"Compiler error: CodeProc with abstract getExecTime().");
		}

		virtual std::string getDotDescriptionExtra() const {
			return std::string() + "\\nET:" + toStr(getExecTime());
		}

		virtual std::string getDotStyle() const {
			if (getState() == CLOSED && isUncertain())
				return "[style=filled, fillcolor=salmon]";
			else if (getState() == SERIALIZED)
				return "[style=filled, fillcolor=greenyellow]";
			else
				return "";
		}

};

#endif //#ifndef __INCLUDE_CODEPROC_HPP__

