#ifndef __INCLUDE_PARENDPROC_HPP__
#define __INCLUDE_PARENDPROC_HPP__

#include "Proc.hpp"
#include "ParProc.hpp"

class ParEndProc : public Proc {
	private:
		ParProc* const par;
		size_t numParents;
	public:
		ParEndProc(Proc* pop, ParProc* par) :
			Proc(pop), par(par), numParents(0) {}

		virtual void removeParent() {
			assert(numParents > 0);
			numParents--;
		}

		virtual void addParent() {
			numParents++;
		}

		size_t getNumParents() const {
			return numParents;
		}

		ParProc* getPar() const {
			return par;
		}

		virtual std::string getName() const {
			return "PAR END";
		}
};

#endif //#ifndef __INCLUDE_PARENDPROC_HPP__

