#include "Proc.hpp"

#include <typeinfo>

unsigned Proc::gProcIndex = 0;

std::string Proc::getName() const {
	return "Proc\\nClass";
}

std::string Proc::getDotDescription() const {
	std::string name = getName();
	std::string descr = std::string() + "\"" + (name.empty() ? "" : name + "\\n") + "[" +
		toStr(procIndex) + "] ";

	if (getState() == CLOSED)
		descr += "+";
	else if (getState() == EXPANDED)
		descr += "-";
	else if (getState() == SERIALIZED)
		descr += "S";
	else if (getState() == DELETABLE)
		descr += "X";
	else
		assert(!"Unknown Proc State");
	
	descr += getDotDescriptionExtra();

	descr += "\"";

	return descr;
}

std::string Proc::getDotStyle() const {
	if (getState() == SERIALIZED)
		return "[style=filled, fillcolor=greenyellow]";
	else if (getState() == DELETABLE)
		return "[style=filled, fillcolor=snow]";
	else
		return "";
}

std::string Proc::getDot() const {
	std::string dot;

	dot = getDotDescription() + " " + getDotStyle() + ";\n";

	if (getChild() != NULL) {
		dot += "\t" + getDotDescription() + " -> " +
			getChild()->getDotDescription() + ";\n";
	}
	else if (countChildren() == 0 && pop != NULL) {
		dot += "\t" + getDotDescription() + " -> " +
			pop->getDotDescription() + " [style=dashed,label=\"pop\"];\n";
	}

	dot += getDotExtra();

	return dot;
}

