#ifndef __INCLUDE_TIMERENDPROC_HPP__
#define __INCLUDE_TIMERENDPROC_HPP__

#include "Proc.hpp"

#include <string>
#include <cassert>

class TimerProc;

class TimerEndProc : public Proc {
	private:
		Proc* next;
		TimerProc* timer;
	public:
		TimerEndProc(Proc* next) : Proc(next), next(next), timer(NULL) {
			assert(next);
		}

		void setTimerProc(TimerProc* timer) {
			this->timer = timer;
		}

		TimerProc* getTimerProc() const {
			return timer;
		}

		virtual std::string getDotStyle() const { 
			if (getState() == SERIALIZED)
				return "[shape=triangle, style=filled, fillcolor=greenyellow]";
			else
				return "[shape=triangle, style=filled, fillcolor=yellow]";
		}

		virtual std::string getName() const {
			return std::string("  ");
		}

		virtual void expand() {
			connect(next);
		}
};


#endif //#ifndef __INCLUDE_TIMERENDPROC_HPP__

