#ifndef __INCLUDE_LIB_HPP__
#define __INCLUDE_LIB_HPP__

#include <algorithm>
#include <string>
#include <sstream>

template <class T>
std::string toStr(const T& v) {
	std::ostringstream strout;

	strout << v;
	return strout.str();
}

template <class ListClass, class EqualityComparable>
bool has(ListClass list, const EqualityComparable& value) {
	return std::find(list.begin(), list.end(), value) != list.end();
}

template <class InputIterator, class EqualityComparable>
bool has(InputIterator first, InputIterator last, const EqualityComparable& value) {
	return std::find(first, last, value) != last();
}

#endif //#ifndef __INCLUDE_LIB_HPP__

