#ifndef __INCLUDE_TAKE_HPP__
#define __INCLUDE_TAKE_HPP__

#include <vector>

class Proc;
template <class T> class SendChannel;
template <class T> class ReceiveChannel;
template <class T> class Channel;
template <class T> class ChannelVector;

// Take control of channel, so that scheduler knows that proc t owns the
// channel, or an end of the channel.

// // Vector of SendChannels
// template <class T>
// void doTake(Proc* t, std::vector<SendChannel<T>*>* vec) {
// 	for (size_t i = 0; i < vec->size(); ++i)
// 		(*vec)[i]->setOwner(t);
// }
// 
// // Vector of ReceiveChannels
// template <class T>
// void doTake(Proc* t, std::vector<ReceiveChannel<T>*>* vec) {
// 	for (size_t i = 0; i < vec->size(); ++i)
// 		(*vec)[i]->setOwner(t);
// }
// 
// // Vector of Channels
// template <class T>
// void doTake(Proc* t, std::vector<Channel<T>*>* vec) {
// 	for (size_t i = 0; i < vec->size(); ++i)
// 		(*vec)[i]->setOwner(t);
// }

// Single SendChannel
template <class T>
void doTake(Proc* t, SendChannel<T>* var) {
	var->setOwner(t);
}

// Single ReceiveChannel
template <class T>
void doTake(Proc* t, ReceiveChannel<T>* var) {
	var->setOwner(t);
}

// Single Channel
template <class T>
void doTake(Proc* t, Channel<T>* var) {
	var->setOwner(t);
}

// Other variables: do nothing.
template <class T>
void doTake(Proc* t, T* var) {}


// makeSend/makeReceive takes only the send/receive part of a Channel, to allow
// splitting each end of a channel into separate processes.

// makeSend for vector of Channels
template <class T>
std::vector<SendChannel<T>*>* makeSend(ChannelVector<T>* chv) {
	return chv->getSendChannelVector();
}

// makeReceive for vector of Channels
template <class T>
std::vector<ReceiveChannel<T>*>* makeReceive(ChannelVector<T>* chv) {
	return chv->getReceiveChannelVector();
}

// makeSend for single Channel
template <class T>
SendChannel<T>* makeSend(Channel<T>* ch) {
	return ch->getSendChannel();
}

// makeReceive for single Channel
template <class T>
ReceiveChannel<T>* makeReceive(Channel<T>* sch) {
	return sch->getReceiveChannel();
}


#endif //#ifndef __INCLUDE_TAKE_HPP__
